# -*- coding: utf-8 -*-
"""
Created on Fri Feb 18 17:06:16 2022

@author: rcboot
"""

import scipy as s
from scipy import optimize as opp
import numpy as np
import matplotlib.pyplot as plt
import pandas as pd
import cv2
import argparse as ar1
import pandas as pd
from scipy.stats import skew
from scipy.stats import norm
from scipy.stats import kurtosis
import scipy.optimize as s1
import math as m
from pathlib import Path
import os
plt.style.use("classic")

#First, we import the Excel file with data and make a standard plot.

path = Path(__file__).parent.parent.parent.parent / 'Results' / 'Spheroid aspiration' / 'NEW design' / 'Last 6 months' /'14-7-2023'/'NIH Day 2 1,5M pluronic+ibidi'/'Exp1 Plots' 
os.chdir(str(path))

Database = pd.read_excel (path/'CreepDataAllChannelsCombinedAspandRetr.xlsx')
#print (Database["Creep ($\mu$m)"])

#Now, we perform a least square operation.

xvaluesAll = Database["Time Step (secs)"]
xvalues1 = xvaluesAll[0:160]
xvaluesRetr = xvaluesAll[160:321]
xvalues2 = xvaluesAll[321:482]
yvaluesAll = Database["Creep7 ($\mu$m)"]
yvalues1 = yvaluesAll[0:160]
yvaluesRetr = yvaluesAll[160:321]
Lmax = yvaluesAll[0]
#yvalues2 = np.array(list(yvaluesRetr))
#print(Lmax)

#print(yvalues1)
#xvalues = Database["Time Step (secs)"]
#xvalues1 = xvaluesAll[0:22]
#xvalues2 = xvaluesAll[22:65:5]
#xvalues = np.array(list(xvalues1)+list(xvalues2))

#yvalues = Database["Creep ($\mu$m)"]
#yvalues1 = yvaluesAll[0:22]
#yvalues2 = yvaluesAll[22:65:5]
#yvalues = np.array(list(yvalues1)+list(yvalues2))

#This is the Modified Maxwell Model used by Brochard-Wyart et al.

def Modified_Maxwell(t, A, B, C, D):
    return A*t + B - C*np.exp(-t/D)

def Residual_Modified_Maxwell(p, x, y):
    return (y - Modified_Maxwell(x, *p))

MM0 = [-0.0001, 50., 10., 1]
MM02 = [-0.0001, 80., 10., 1]

DataMMopt1, conv = opp.leastsq(Residual_Modified_Maxwell, MM0, args = (xvalues1,
yvalues1))

YfitMM1 = Modified_Maxwell(xvalues1, *DataMMopt1)

DataMMopt2, conv = opp.leastsq(Residual_Modified_Maxwell, MM02, args = (xvaluesRetr,
yvaluesRetr))

YfitMM2 = Modified_Maxwell(xvaluesRetr, *DataMMopt2)

plt.figure(figsize =(7,6))

#axis thickness
plt.tick_params(which='both', width=2)
plt.tick_params(which='major', length=7)
plt.tick_params(which='minor', length=4)# #color='r')

#axis numbers font sizes
plt.xticks(fontsize=15, rotation=0)
plt.yticks(fontsize=15)
plt.plot(xvalues1, yvalues1, marker =
".", linestyle = "none", markersize = "9", color = 'orange')
plt.plot(xvalues2, yvaluesRetr, marker =
".", linestyle = "none", markersize = "9", color = 'orange')
plt.plot(xvalues1, YfitMM1, linestyle = "--", linewidth ="3",
color = "black", label = "MM Model")
plt.plot(xvalues2, YfitMM2, linestyle = "--", linewidth ="3",
color = "black", label = "MM Model")
plt.margins(0.01, 0.1)
plt.xlim([-1,61])
plt.ylim([0, max(yvalues1)+10])
#plt.xlabel("Time [sec]", size = 15)
#plt.ylabel("Aspiration L(t) [$\mu$m]", size = 15)
#plt.legend(prop={'size': 15}, numpoints = 1, loc = "upper left")
plt.savefig("Creep_Pocket7AspandRetr.jpg",bbox_inches = "tight", dpi = 300)

plt.xticks(fontsize=15, rotation=0)
plt.yticks(fontsize=15)
#plt.plot(xvalues2, yvalues2, marker =
#".", linestyle = "none", markersize = "9", color = 'orange')
#plt.plot(xvalues2, YfitMM2, linestyle = "--", linewidth ="3",
#color = "black", label = "MM Model")
plt.margins(0.01, 0.1)
#plt.ylim([0, max(yvalues2)+10])
plt.xlabel("Time [sec]", size = 15)
#plt.ylabel("Aspiration and Retraction L(t) [$\mu$m]", size = 15)
#plt.legend(prop={'size': 15}, numpoints = 1, loc = "upper left")
#plt.savefig("Creep_Pocket8AspenRetr.jpg",bbox_inches = "tight", dpi = 300)

#Residuals = yvalues1 - YfitMM
#mu, std = norm.fit(Residuals)
#Skewness = skew(Residuals)
#Kurtosis = kurtosis(Residuals)
#print(std)

#This is to calculate the final values of the moduli

L = 50 #micrometers
#Reff = 32.5
Reff = ((2/np.pi)*((L**4)/(4*0.5928*3)))**(1/4)
#print(Reff)

ParamA1 = DataMMopt1[0]
ParamB1 = DataMMopt1[1]
ParamC1 = DataMMopt1[2]
ParamD1 = DataMMopt1[3]

#ParamA2 = DataMMopt2[0]
#ParamB2 = DataMMopt2[1]
#ParamC2 = DataMMopt2[2]
#ParamD2 = DataMMopt2[3]

DeltaP = 1500 #Pascal
#DeltaPc = DeltaP*((-ParamA2)/((-ParamA2)+ParamA1))

deltaRetr = Lmax - ParamB1

#Maxwell
n1 = Reff*(DeltaP)/(3*np.pi*ParamA1)
E1 =  Reff*(DeltaP)/ParamB1
#n1Pc = Reff*(DeltaP-DeltaPc)/(3*np.pi*ParamA1)
#E1Pc =  Reff*(DeltaP-DeltaPc)/ParamB1
#E2 = E1/(((R*DeltaP)/(ParamC*E1))-1)
#n2 = E1*E2*ParamD/(3*np.pi*(E1+E2))

#ST = DeltaPc/(2*((1/Reff)-(1/103))*1000) #mN/m

print(ParamA1)
#print(ParamA2)
#print(DeltaPc)
#print(E1Pc,n1Pc)
print(E1,n1)
print(Lmax)
print(ParamB1)
print(deltaRetr)