# -*- coding: utf-8 -*-
"""
Created on Fri Feb 18 17:06:16 2022

@author: rcboot
"""

import scipy as s
from scipy import optimize as opp
import numpy as np
import matplotlib.pyplot as plt
import pandas as pd
import cv2
import argparse as ar1
import pandas as pd
from scipy.stats import skew
from scipy.stats import norm
from scipy.stats import kurtosis
import scipy.optimize as s1
import math as m
from pathlib import Path
import os
import seaborn as sns
plt.style.use("classic")

#First, we import the Excel file with data and make a standard plot.

path = Path(__file__).parent.parent / 'Results' / 'Spheroid aspiration' / 'NEW design' /'Last 6 months'/ 'Plots'
os.chdir(str(path))

Database = pd.read_excel (path/'NIH Plot File.xlsx')

Param1Data = Database["L_r2 (um/s)"]
Param1A = Param1Data[0:48]
#Param1Orange = Param1Data[31:57]
#Param1B = np.array(list(Param1Orange))
#Param1 = np.array(list(Param1A)+list(Param1B))

Param2Data = Database["L_r1 (um/s)"]
Param2A = Param2Data[0:57]
#Param2Orange = Param2Data[12:15]
#Param2B = np.array(list(Param2Orange))
#Param2 = np.array(list(Param2A)+list(Param2B))

Param3Data = Database["L_r3 (um/s)"]
Param3A = Param3Data[0:35]

Param4Data = Database["L_r2A (um/s)"]
Param4A = Param4Data[0:48]

Param5Data = Database["L_r1A (um/s)"]
Param5A = Param5Data[0:57]


xvaluesParam1 = [Param1A,Param2A,Param3A,Param4A,Param5A]
#xvaluesParam2 = [Param1B, Param2B]
xmeanParam = [0.012,0.016,0.032,0.030,0.033]
SEMParam = [0.0005,0.0008,0.001,0.0007,0.0009]

spotsize = 1.5
col = '#474747'
colbar = 'grey'
linwid = 1.0
capsiz = 0.4
rot = 0
jit = 0.2
#clrs = ['#C1CDCD', '#C1CDCD', '#C1CDCD','#C1CDCD','#C1CDCD','#C1CDCD']
#facecolor=(1, 1, 1, 0),

X1 = range(5)
xlabels1Param = ["1000", "1200","2000","1000 /10", "1200/10"]

sns.set(style='whitegrid')
f = plt.figure(figsize=[2.5,3])

a = sns.swarmplot(data = xvaluesParam1, linewidth=linwid, size=spotsize, color = '#474747')
#b = sns.swarmplot(data = xvaluesParam2, linewidth=linwid, size=spotsize, color = 'orange')
plt.bar(X1, xmeanParam, linewidth=linwid, width=0.5, color=['#e28743','#e28743','#e28743','#b5c576','#b5c576'], edgecolor='black')
plt.errorbar(x=X1, y=xmeanParam, yerr=SEMParam, fmt='none', zorder=200, color=col,
                 ecolor='red', elinewidth=3, capsize=1)
a.set_xticklabels(xlabels1Param, rotation=rot)
#plt.ylabel('ST (mN/m')
plt.ylim((0,0.065))
a.grid(False)

sns.despine()
a.spines['left'].set_linewidth(2)
a.spines['left'].set_color('black')
a.spines['bottom'].set_linewidth(2)
a.spines['bottom'].set_color('black')
a.yaxis.set_ticks_position('left')
a.xaxis.set_ticks_position('bottom')
a.tick_params(axis='x', labelsize = 7)
#a.set_xticklabels([])
#a.set_yticklabels([])

f.savefig("Lr Comparison 5 conditions.jpg",bbox_inches = "tight", dpi = 300)


