# -*- coding: utf-8 -*-
"""
Created on Fri Feb 18 17:06:16 2022

@author: rcboot
"""

import scipy as s
from scipy import optimize as opp
import numpy as np
import matplotlib.pyplot as plt
import pandas as pd
import cv2
import argparse as ar1
import pandas as pd
from scipy.stats import skew
from scipy.stats import norm
from scipy.stats import kurtosis
import scipy.optimize as s1
import math as m
from pathlib import Path
import os
plt.style.use("classic")

#First, we import the Excel file with data and make a standard plot.

path = Path(__file__).parent.parent.parent.parent / 'Results' / 'Spheroid aspiration' / 'NEW design' / 'Last 6 months'/'Plots' 
os.chdir(str(path))

Database = pd.read_excel (path/'NIH Plot File Gesorteerd.xlsx')
#print (Database["Creep ($\mu$m)"])

#Now, we perform a least square operation.

xvaluesAll = Database["L_r31 (um/s)"]
xvalues = xvaluesAll[0:35]
#xvaluesOrange = xvaluesAll[12:15]
#xvalues2 = np.array(list(xvaluesOrange))
yvaluesAll = Database["L_a31 (um/s)"]
yvalues = yvaluesAll[0:35]
#yvaluesOrange = yvaluesAll[12:15]
#yvalues2 = np.array(list(yvaluesOrange))
#print(yvalues1)
#print(yvalues2)


#xvalues = np.array(list(xvalues1)+list(xvalues2))
#yvalues = np.array(list(yvalues1)+list(yvalues2))

#print(yvalues)

#This is the Modified Maxwell Model used by Brochard-Wyart et al.

def Linear(t, A, B):
    return A*t + B

def Residual_Linear(p, x, y):
    return (y - Linear(x, *p))

L0 = [1., 1.]

DataLopt1, conv = opp.leastsq(Residual_Linear, L0, args = (xvalues,
yvalues))

YfitL1 = Linear(xvalues, *DataLopt1)

#print(YfitL1)

plt.figure(figsize =(7,7))

#axis thickness
plt.tick_params(which='both', width=2)
plt.tick_params(which='major', length=7)
plt.tick_params(which='minor', length=4)# #color='r')

#axis numbers font sizes
plt.xticks(fontsize=20, rotation=0)
plt.yticks(fontsize=20)
plt.plot(xvalues, yvalues, marker =
".", linestyle = "none", markersize = "15", color = '#192e9c')
#plt.plot(xvalues2, yvalues2, marker =
#".", linestyle = "none", markersize = "9", color = 'orange')
plt.plot(xvalues, YfitL1, linestyle = "--", dashes=(10, 10), linewidth ="3",
color = "black", label = "Linear Fit")
plt.margins(0.01, 0.1)
plt.ylim([0, max(yvalues)+0.003])
#plt.xlabel("R0 [um]", size = 15)
#plt.ylabel("ST [mN/m]", size = 15)
#plt.legend(prop={'size': 15}, numpoints = 1, loc = "upper left")
plt.savefig("LavsLr 2000 Pa.jpg",bbox_inches = "tight", dpi = 300)


#Residuals = yvalues1 - YfitMM
#mu, std = norm.fit(Residuals)
#Skewness = skew(Residuals)
#Kurtosis = kurtosis(Residuals)
#print(std)


