# -*- coding: utf-8 -*-
"""
Created on Fri Feb 18 17:06:16 2022

@author: rcboot
"""

import scipy as s
from scipy import optimize as opp
import numpy as np
import matplotlib.pyplot as plt
import pandas as pd
import cv2
import argparse as ar1
import pandas as pd
from scipy.stats import skew
from scipy.stats import norm
from scipy.stats import kurtosis
import scipy.optimize as s1
import math as m
from pathlib import Path
import os
plt.style.use("classic")

#First, we import the Excel file with data and make a standard plot.

path = Path(__file__).parent.parent / 'Results' / 'Spheroid aspiration' / 'NEW design' /'Alessio Data'/'Creep comparison 700 Pa and 500 Pa'
os.chdir(str(path))

Database1 = pd.read_excel (path/'CreepDataAllChannels_700PaRandomSelectie.xlsx')
Database2 = pd.read_excel (path/'CreepDataAllChannels_14-7-2022_Exp3.xlsx')
Database3 = pd.read_excel (path/'CreepDataAllChannels_20-7-2022_Exp3.xlsx')
Database4 = pd.read_excel (path/'CreepDataAllChannels_20-7-2022_Exp5.xlsx')

xvaluesAll1 = Database1["Time Step 1 (secs)"]
xvalues1 = xvaluesAll1[0:58]
yvaluesAll1 = Database1["Creep1 ($\mu$m)"]
yvalues1 = yvaluesAll1[0:58]
yvaluesAll2 = Database1["Creep2 ($\mu$m)"]
yvalues2 = yvaluesAll2[0:58]

xvaluesAll2 = Database1["Time Step 2 (secs)"]
xvalues2 = xvaluesAll2[0:58]
yvaluesAll3 = Database1["Creep3 ($\mu$m)"]
yvalues3 = yvaluesAll3[0:58]
yvaluesAll4 = Database1["Creep4 ($\mu$m)"]
yvalues4 = yvaluesAll4[0:58]

xvaluesAll3 = Database1["Time Step 3 (secs)"]
xvalues3 = xvaluesAll3[0:58]
yvaluesAll5 = Database1["Creep5 ($\mu$m)"]
yvalues5 = yvaluesAll5[0:58]

xvaluesAll4 = Database1["Time Step 4 (secs)"]
xvalues4 = xvaluesAll4[0:58]
yvaluesAll6 = Database1["Creep6 ($\mu$m)"]
yvalues6 = yvaluesAll6[0:58]

xvaluesAll5 = Database2["Time Step (secs)"]
xvalues5 = xvaluesAll5[0:58]
yvaluesAll7 = Database2["Creep5 ($\mu$m)"]
yvalues7 = yvaluesAll7[0:58]
yvaluesAll8 = Database2["Creep6 ($\mu$m)"]
yvalues8 = yvaluesAll8[0:58]

xvaluesAll6 = Database3["Time Step (secs)"]
xvalues6 = xvaluesAll6[0:58]
yvaluesAll9 = Database3["Creep2 ($\mu$m)"]
yvalues9 = yvaluesAll9[0:58]
yvaluesAll10 = Database3["Creep6 ($\mu$m)"]
yvalues10 = yvaluesAll10[0:58]

xvaluesAll7 = Database4["Time Step (secs)"]
xvalues7 = xvaluesAll7[0:58]
yvaluesAll11 = Database4["Creep1 ($\mu$m)"]
yvalues11 = yvaluesAll11[0:58]
yvaluesAll12 = Database4["Creep2 ($\mu$m)"]
yvalues12 = yvaluesAll12[0:58]


plt.figure(figsize =(9,7))
plt.plot(xvalues1, yvalues1, linestyle = "-", linewidth ="3",
color = "red", label = "Spheroid 700 Pa")
plt.plot(xvalues1, yvalues2, linestyle = "-", linewidth ="3",
color = "red", label = "Spheroid 700 Pa")
plt.plot(xvalues2, yvalues3, linestyle = "-", linewidth ="3",
color = "red", label = "Spheroid 700 Pa")
plt.plot(xvalues2, yvalues4, linestyle = "-", linewidth ="3",
color = "red", label = "Spheroid 700 Pa")
plt.plot(xvalues3, yvalues5, linestyle = "-", linewidth ="3",
color = "red", label = "Spheroid 700 Pa")
plt.plot(xvalues4, yvalues6, linestyle = "-", linewidth ="3",
color = "red", label = "Spheroid 700 Pa")
plt.plot(xvalues5, yvalues7, linestyle = "-", linewidth ="3",
color = "blue", label = "Spheroid 500 Pa, E = 192")
plt.plot(xvalues5, yvalues8, linestyle = "-", linewidth ="3",
color = "orange", label = "Spheroid 500 Pa, E = 199")
plt.plot(xvalues6, yvalues9, linestyle = "-", linewidth ="3",
color = "green", label = "Spheroid 500 Pa, E = 146")
plt.plot(xvalues6, yvalues10, linestyle = "-", linewidth ="3",
color = "cyan", label = "Spheroid 500 Pa, E = 166")
plt.plot(xvalues7, yvalues11, linestyle = "-", linewidth ="3",
color = "purple", label = "Spheroid 500 Pa, E = 136")
plt.plot(xvalues7, yvalues12, linestyle = "-", linewidth ="3",
color = "yellow", label = "Spheroid 500 Pa, E = 213")

#axis thickness
plt.tick_params(which='both', width=2)
plt.tick_params(which='major', length=7)
plt.tick_params(which='minor', length=7)

#axis numbers font sizes
plt.xticks(fontsize=15, rotation=0)
plt.yticks(fontsize=15)
plt.xlabel("Time [s]", size = 15)
plt.ylabel("Creep [$\mu$m]", size = 15)
plt.legend(prop={'size': 15}, numpoints = 1, loc = 'lower right')
plt.savefig("Creep_700Pa&500Pa_Comparison.jpg", bbox_inches = "tight", dpi = 300)

