# -*- coding: utf-8 -*-
"""
Created on Tue Nov  2 14:35:08 2021

@author: rcboot
"""

import scipy as s
from scipy import optimize as opp
import numpy as np
import matplotlib.pyplot as plt
import pandas as pd
import cv2
import argparse as ar1
import pandas as pd
from scipy.stats import skew
from scipy.stats import norm
from scipy.stats import kurtosis
import scipy.optimize as s1
import math as m
from pathlib import Path
import os
plt.style.use("classic")

# Open a file with the binary image and define height
path = Path(__file__).parent.parent / 'Results' / 'MPA' / 'Lennard MPA latest 7-9-2022' /'HEK293T Day 2 5 cm H2O PLL-PEG coating NO 37C YES old CO2 media 1 image per s [2M cells]'/'7-9-2022'/ 'Chamber 2'/'Spheroid 5' / 'Asp' 
os.chdir(str(path))
tasp = cv2.imread("Asp0000.jpg", cv2.IMREAD_UNCHANGED)
image_height = tasp.shape[0]
print(image_height)
#cv2.imshow('Original_image',tasp)
#filtered_image = cv2.GaussianBlur(tasp,(9,9),0)
#cv2.imshow('Filtertest',filtered_image)
#cv2.waitKey(0)

#data = tasp[0, 134] #[y-axis, x-axis]
#print(data)
#print(tasp)

#Define square array which contains top of white channel, 
#excluding potential black specs in the tongue.
range_y = [64,70]
range_x = [17, 73]
mask_locator = tasp

store_x_range = []

counter = 0

#for i in range(range_x[0], range_x[1]):
#    counter = 0
#    for j in range(range_y[0], range_y[1]):
#        check_binary = mask_locator[j,i]
#        if(check_binary[0] <=0):
#            counter += 1
#            break;
#    if (counter == 0):
#            store_x_range.append(i)
#print(store_x_range)

#Define middle of channel

#middle = float(len(store_x_range))/2

#if middle % 2 != 0:
#    midvalue = store_x_range[int(middle - .5)]
#else:
#    midvalue = store_x_range[int(middle)]
#print(midvalue)
 
#Naming funtion to call the images

def Naming(base_name, sv, fv, digits):

    full_name = []
    zero = str(0)
    total_zero = ""
    for i in range(sv, fv+1):
        if (i<10):
            add_zeros = digits-1
            for j in range(add_zeros):
                total_zero = total_zero + zero
        if (i>= 10 and i<100):
            add_zeros = digits-2
            for j in range(add_zeros):
                total_zero = total_zero + zero
        if (i>= 100 and i<1000):
            add_zeros = digits-3
            for j in range(add_zeros):
                total_zero = total_zero + zero
        if (i>= 1000 and i<10000):
            add_zeros = digits-4
            for j in range(add_zeros):
                total_zero = total_zero + zero
        full_name.append(base_name+total_zero+str(i)+".jpg")
        total_zero = ""
    return full_name

basename = "Asp"
digits = 4
start_value = 5
end_value = 300
name_array = Naming(basename, start_value, end_value, digits)
#print(name_array)

#Function to measure aspiration in single image

def Aspiration(filename, channel_length):
    image = cv2.imread(filename)
    extension = 0
    for i in range(10,channel_length):
        data1, data2, data3 = image[i,72]#midvalue
            
        if(data1<=10):
            extension = channel_length-i
            break
    return extension

#Funtion to measure aspiration in time series

def Displacement(namearray, channel_length):
    
    creep_serie = []
    frame_index = []
    
    for i in range(0,len(namearray)):
        data = Aspiration(namearray[i], channel_length)
        creep_serie.append(data)
        frame_index.append(i)
        
        #if (creep_serie[0] != 0):
            #creep_serie.insert(0,0)
            #frame_index.insert(0,0)
    return creep_serie, frame_index

#Collect data

Database = pd.DataFrame()
time_steps = 1 # seconds per snap
channel_length = image_height #pixels
distance_to_pixel_ratio = 0.65 # microns per pixel
creep_data = Displacement(name_array, channel_length)

Database["Serial number"] = creep_data[1] #frame_index
Database["Time Step (secs)"] = (Database["Serial number"]+1)*time_steps
Database["Creep (pixels)"] = creep_data[0] #creep_bundle_mean
Database["Creep ($\mu$m)"] = Database["Creep (pixels)"]*distance_to_pixel_ratio

#print(Database[["Time Step (secs)","Creep (pixels)","Creep ($\mu$m)"]])

#Export data to excel file

file_name = 'CreepData.xlsx'
Database.to_excel(file_name)